<?php

namespace Drupal\eav_field\Plugin\Derivative;

use Drupal\Component\Plugin\Derivative\DeriverBase;
use Drupal\Core\Entity\EntityFieldManagerInterface;

class EavFieldLocalTaskDeriver extends DeriverBase {

  /**
   * {@inheritDoc}
   */
  public function getDerivativeDefinitions($base_plugin_definition) {
    $entity_field_manger = \Drupal::service('entity_field.manager'); /** @var EntityFieldManagerInterface $entity_field_manger */
    $eav_fields = $entity_field_manger->getFieldMapByFieldType('eav');

    foreach (array_keys($eav_fields) as $entity_type_id) {
      $this->derivatives[$entity_type_id] = [
        'title' => t('Edit EAV attributes'),
        'route_name' => "entity.$entity_type_id.edit_eav_attributes",
        'base_route' => "entity.$entity_type_id.canonical",
        'weight' => 20,
      ] + $base_plugin_definition;
    }

    return parent::getDerivativeDefinitions($base_plugin_definition);
  }

}
