<?php

namespace Drupal\eav_field\Plugin\Field\FieldType;

use Drupal\Core\Field\EntityReferenceFieldItemList;
use Drupal\Core\Form\FormStateInterface;

class EavItemList extends EntityReferenceFieldItemList {

  /**
   * {@inheritdoc}
   */
  public function defaultValuesForm(array &$form, FormStateInterface $form_state) {}

  /**
   * Return field item by attribute id or machine name.
   *
   * @param mixed $attribute Attribute id or machine name
   *
   * @return EavItem
   */
  public function getItemByAttribute($attribute) {
    $attribute_id = is_numeric($attribute) ? $attribute : NULL;
    $attribute_name = !is_numeric($attribute) ? $attribute : NULL;

    /** @var EavItem $eav_item */
    foreach ($this as $eav_item) {
      $eav_value = $eav_item->getValueEntity();

      // By id
      if ($attribute_id) {
        if ($attribute_id == $eav_value->getAttributeId()) {
          return $eav_item;
        }
      }
      // By machine name
      else {
        $attribute = $eav_value->getAttributeEntity();
        if ($attribute && $attribute_name == $attribute->getMachineName()) {
          return $eav_item;
        }
      }
    }
  }

}
